#
# spec file for package swift-im
#
# Copyright (c) 2019 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%define _name swift
%if 0%{?sle_version} == 120300 || 0%{?sle_version} == 120200
%define _flags V=1 swiften_dll=1 test=none optimize=1 debug=0 cc=gcc-6 cxx=g++-6 cxxflags='%{optflags}'
%else
%define _flags V=1 swiften_dll=1 test=none optimize=1 debug=0 cxxflags='%{optflags}'
%endif
Name:           swift-im
Version:        4.0
Release:        lp152.5.55
Summary:        XMPP client
License:        GPL-3.0-only
Group:          Productivity/Networking/Talk/Clients
Url:            http://swift.im/
Source0:        http://swift.im/downloads/releases/%{_name}-%{version}/%{_name}-%{version}.tar.gz
Source1:        http://swift.im/downloads/releases/%{_name}-%{version}/%{_name}-%{version}.tar.gz.asc
Source2:        %{name}.keyring
Patch0:         swift-4.0-qt5.11-includes.patch
Patch1:         swift-im-boost-tribool.patch
BuildRequires:  desktop-file-utils
BuildRequires:  docbook-dtds
BuildRequires:  fdupes
BuildRequires:  hicolor-icon-theme
BuildRequires:  libboost_atomic-devel
BuildRequires:  libboost_date_time-devel
BuildRequires:  libboost_filesystem-devel
BuildRequires:  libboost_headers-devel
BuildRequires:  libboost_program_options-devel
BuildRequires:  libboost_regex-devel
BuildRequires:  libboost_serialization-devel
BuildRequires:  libboost_system-devel
BuildRequires:  libboost_thread-devel
BuildRequires:  libminiupnpc-devel
BuildRequires:  lua53
BuildRequires:  pkgconfig
BuildRequires:  python2-base
BuildRequires:  python2-xml
BuildRequires:  update-desktop-files
BuildRequires:  pkgconfig(Qt5Core)
BuildRequires:  pkgconfig(Qt5DBus)
BuildRequires:  pkgconfig(Qt5Gui)
BuildRequires:  pkgconfig(Qt5Multimedia)
BuildRequires:  pkgconfig(Qt5Network)
BuildRequires:  pkgconfig(Qt5Svg)
BuildRequires:  pkgconfig(Qt5UiTools)
BuildRequires:  pkgconfig(Qt5WebKit)
BuildRequires:  pkgconfig(Qt5WebKitWidgets)
BuildRequires:  pkgconfig(Qt5Widgets)
BuildRequires:  pkgconfig(Qt5X11Extras)
BuildRequires:  pkgconfig(avahi-client)
BuildRequires:  pkgconfig(expat)
BuildRequires:  pkgconfig(gconf-2.0)
BuildRequires:  pkgconfig(hunspell)
BuildRequires:  pkgconfig(libedit)
BuildRequires:  pkgconfig(libidn)
BuildRequires:  pkgconfig(libxml-2.0)
BuildRequires:  pkgconfig(libxslt)
BuildRequires:  pkgconfig(openssl)
BuildRequires:  pkgconfig(python)
BuildRequires:  pkgconfig(xscrnsaver)
BuildRequires:  pkgconfig(zlib)
%if 0%{?sle_version} == 120300 || 0%{?sle_version} == 120200
BuildRequires:  -gcc
BuildRequires:  -gcc-c++
BuildRequires:  gcc6
BuildRequires:  gcc6-c++
%endif

%description
Swift is a Jabber/XMPP instant messaging chat application.

# -------------------------------- swiften ---------------------------

%package -n libSwiften4
Summary:        XMPP client/server library
Group:          System/Libraries

%description -n libSwiften4
Swiften is a C++ library for implementing XMPP applications.

# ------------------------------ swiften-devel -----------------------

%package -n swiften-devel
Summary:        Development files for the Swiften XMPP client/server library
Group:          Development/Libraries/C and C++
Requires:       libSwiften4 = %{version}

%description -n swiften-devel
Swiften is a C++ library for implementing XMPP applications.

%prep
%setup -q -n swift-4.0
%patch0 -p1
%patch1 -p1

# Remove 3rd party libraries
# Following ones are used from distro:
find 3rdParty/Boost/src -delete
find 3rdParty/Expat/src -delete
find 3rdParty/LibIDN -delete
find 3rdParty/Lua -delete
find 3rdParty/ZLib -delete
find 3rdParty/OpenSSL -delete
find 3rdParty/DocBook -delete
# P2P
find 3rdParty/LibMiniUPnPc -delete
find 3rdParty/LibNATPMP -delete
# DNS (they use it on Android)
find 3rdParty/Unbound -delete
find 3rdParty/Ldns -delete
# Only for developers
find 3rdParty/LCov -delete
# Not used by swift yet
find 3rdParty/Breakpad/src -delete
find 3rdParty/SQLite -delete
# They use scons in a way that doesnt allow us to use our CppUnit
# find 3rdParty/CppUnit -delete
# Needed for tests
# find 3rdParty/HippoMocks -delete

%build
./scons %{_flags} Swift Swiften %{?_smp_mflags} boost_bundled_enable=false

%install
./scons %{_flags} \
    SWIFT_INSTALLDIR=%{buildroot}%{_prefix} \
    SWIFTEN_INSTALLDIR=%{buildroot}%{_prefix} \
    SWIFTEN_LIBDIR=%{buildroot}%{_libdir} \
    %{buildroot}%{_prefix}

%fdupes %{buildroot}%{_prefix}
%suse_update_desktop_file -r %{_name} Network InstantMessaging

%icon_theme_cache_post
%icon_theme_cache_postun

%post -n libSwiften4 -p /sbin/ldconfig
%postun -n libSwiften4 -p /sbin/ldconfig

%files
%license COPYING

%{_bindir}/%{_name}-im
%{_bindir}/%{_name}-open-uri
%{_datadir}/applications/%{_name}.desktop
%{_datadir}/pixmaps/%{_name}.xpm
%{_datadir}/icons/hicolor/*/apps/%{_name}.png
%{_datadir}/icons/hicolor/32x32/apps/%{_name}.xpm
%{_datadir}/icons/hicolor/scalable/apps/%{_name}.svg
%dir %{_datadir}/%{_name}
%dir %{_datadir}/%{_name}/sounds
%{_datadir}/%{_name}/sounds/message-received.wav
%dir %{_datadir}/%{_name}/translations
%{_datadir}/%{_name}/translations/swift_*.qm

%files -n libSwiften4
%{_libdir}/libSwiften.so.*

%files -n swiften-devel
%{_bindir}/swiften-config
%{_includedir}/Swiften
%{_libdir}/libSwiften.so

%changelog
* Mon Apr  1 2019 mvetter@suse.com
- Add swift-im-boost-tribool.patch: Fix for boost >= 1.69.0
- Remove deprecated libboost_signals-devel
  swift-im uses signal2 which is in libboost_headers-devel
* Tue Jun 12 2018 mvetter@suse.com
- Add swift-4.0-qt5.11-includes.patch:
  Add includes explicitly, so it builds with Qt 5.11
* Thu Mar 22 2018 jengelh@inai.de
- Remove filler wording and bias from descriptions.
* Wed Mar 21 2018 mvetter@suse.com
- Add GPG checking
  * Add swift-4.0.tar.gz.asc
  * Add swift.keyring
* Tue Mar 20 2018 mvetter@suse.com
- Update to version 4.0:
  * New chat theme including a new font
  * Support for message carbons (XEP-0280)
  * Enabled trellis mode as a default feature, allowing several tiled chats windows to be shown at once
  * Redesigned keyword highlighting
  * Improve date formatting
  * Fix Last Message Correction in multi client scenarios
  * Fix UI layout issue for translations that require right-to-left (RTL) layout
  * Fix UX issues in trellis mode
  * Improvements to font size handling in the chat theme
  * Improved spell checker support on Linux
  * And assorted smaller features and usability enhancements
* Wed Feb 28 2018 fisiu@opensuse.org
- Altering Swift/QtUI/SConscript is no longer required.
* Tue Dec 12 2017 mvetter@suse.com
- Update to version 4RC3:
  * Fix crash in emoticon dialog
  * Update translations ( Dutch, German )
  * And smaller bug fixes
* Mon Dec 11 2017 mpluskal@suse.com
- Use bundled scons for now
- Drop swift-im-scons-python3.patch
* Thu Nov 30 2017 mvetter@suse.com
- Convert scons files to use python3
* Wed Nov 22 2017 mvetter@suse.com
- bsc#1062799:
  * Replace big boost-devel with only required boost devel libs
  * Use boost_bundled_enable=false switch
* Thu Oct 19 2017 fisiu@opensuse.org
- Use gcc6 for Leap to fix compilation issue.
* Tue Oct 17 2017 fisiu@opensuse.org
- Spec cleanup.
- Ship translations within the package.
* Fri Jun  9 2017 mvetter@suse.com
- Update to version	4.0 beta 2:
  * Support for message carbons (XEP-0280)
  * Trellis mode enabled as a default feature, allowing several tiled chats windows to be shown at once
  * New chat theme including a new font
  * Redesigned keyword highlighting
  * Improved spell checker support on Linux
  * Support for automatic software updates on macOS
  * Support for unicode emojis on macOS
  * And assorted smaller features and usability enhancements
- Remove chmod for Swiften/Network/UnboundDomainNameResolver.
  got upstreamed: https://github.com/swift/swift/pull/28
- Remove patches:
  * swift-libminiupnpc.patch: Upstreamed
  * swift-missing-assert.patch: Upstreamed https://github.com/swift/swift/pull/32
  * swift-system-font.patch: Rendering works now. Can use their
  font for the roster
- Add BuildRequires: libqt5-qtsvg-devel needs this to display properly
* Wed Jul 27 2016 mvetter@suse.com
- Add swift-missing-assert.patch: Fix missing include cassert.
  Needed to build successfully on Leap.
* Tue Jul 26 2016 mvetter@suse.com
- Update to version 4 Beta 2:
  * Support for message carbons (XEP-0280)
  * Improved spell checker support on Linux
  * Enabled trellis mode as a default feature, allowing several tiled chats windows to be shown at once
  * New chat theme including a new font
  * And assorted smaller features and usability enhancements
  * Fix Swift bug introduced in 4.0-beta1 that results in the UI sometimes getting stuck during login
- Add:
  * swift-libminiupnpc.patch: Tumbleweed uses libminiupnpc 2.0 this adds support for version 1 and 2
  * swift-system-font.patch: swift brings its own Fonts, which don't look very good
    we stay with the system fonts (for roster, menu. Chatwindow uses Webview with different font)
* Tue May 17 2016 jengelh@inai.de
- Adjust RPM groups
* Wed May 11 2016 mvetter@suse.com
- Use correct Group
* Tue May 10 2016 mvetter@suse.com
- Dont install xpm file twice
* Wed Mar  9 2016 mvetter@suse.com
- Fix for 13.2 by declaring dirs
* Mon Mar  7 2016 mvetter@suse.com
- Remove more 3rdParty libraries and use distribution ones instead.
  Describing what we need and why.
* Fri Mar  4 2016 mvetter@suse.com
- Make spec file cleaner
* Fri Mar  4 2016 mvetter@suse.com
- Create initial package for version 3.0
